ENTRY(test)

__RAM_SIZE = 0x40000;
__RAM_START = 0;
__RAM_END  = __RAM_START + __RAM_SIZE;  /* First byte beyond the end of RAM */

/* Define stack to start near the top of RAM (grows downward)... */
__stack_top = ( (__RAM_END - 1) & 0xFFFFFFF0);

MEMORY
{
    mainmem : ORIGIN = 0, LENGTH = 0x40000

    RAM : ORIGIN = 0x20000000, LENGTH = 0x80000

    ROM : ORIGIN = 0x40000000, LENGTH = 0x20000
}
SECTIONS
{
    .text   ALIGN (0x4)  :      { _stext = .;
                                  *(.text*) 
                                  *(.gnu.warning) 
                                  *(.gnu.linkonce*) 
                                  *(.init) } >  mainmem  
                                  _etext = .;  
                                  PROVIDE (etext = .); 
    .fini   ALIGN (0x4)  :      { *(.fini) } >  mainmem  
    .rodata1   ALIGN (0x8)  :   { *(.rodata1*) } >  mainmem  
    .rodata   ALIGN (0x8)  :    { *(.rodata*) } >  mainmem  

    .data   ALIGN (0x8)  :      { *(.data*) } >  mainmem
    .got   ALIGN (0x8) :        { _GLOBAL_OFFSET_TABLE_ = ABSOLUTE(.); 
                                  *(.got) *(.got.plt) } >  mainmem
    .sdata ALIGN (0x8) :        { _SDA_BASE_ = ABSOLUTE(. + 32768); 
                                  *(.sdata) *(.sdata.*) } >  mainmem
    .sdata2 ALIGN (0x8) :       { _SDA2_BASE_ = ABSOLUTE(. + 32768); 
                                  *(.sdata2*) } >  mainmem  
    _edata = .; PROVIDE (edata = .); 

    _ALL_BSS_START = ABSOLUTE (.);
    .sbss   ALIGN (0x4)  :      {  *(.sbss) *(.sbss.*) *(.scommon*) } >  mainmem
    .sbss2  ALIGN (0x4)  :      { *(.sbss2*) *(.sbss2.*) } >  mainmem  
    .plt ALIGN (0x8) :          { *(.plt) } > mainmem
    .bss   ALIGN (0x10)  :      { *(.dynbss*) *(.bss*) *(COMMON) } >  mainmem  
    _ALL_BSS_END = ABSOLUTE (.);

    . = ALIGN(4); _end = .; PROVIDE (end = .);
     __heap1   = ALIGN (0x8);

    ram_sect (NOLOAD) : { *(ram_sect) } > RAM

    rom_sect (NOLOAD) : { *(rom_sect) } > ROM
}
